function [ans] = DetectGrapes(I)
warning('off','MATLAB:divideByZero')
G=I;
I= rgb2gray(I);


copy= I;
%Removing the extreme bright areas
%===============================
I = Removeclear(I);  
%Removing small areas that have 0 around them
%========================================
I = Removenoise(I);
%Reconstructing small holes
%=========================
I = FillPic(I,copy,14);
%Removing areas that most likely to be without grapes - colur mismatch and  extreme gradient values
%========================================================================================
I = clear_image(I,G);
%Removing small areas that have 0 around them
%========================================
I = Removenoise(I);
%Reconstructing small holes
%=========================
I = FillPic(I,copy,14);


%using hough transform for reducing non - circular edges
%=================================================
I= houghcircle(I);

%Reconstructing small holes
%=========================
I = FillPic(I,copy,30);
I = FillPic(I,copy,20);

ans = zeros(size(I));
ans(I>0) = 1;

figure;imshow(ans);

end

