function [I] = houghcircle(I)



% edge map using canny
%===================
BW=edge(I,'canny',0.06,0.9);

%

[Row Col] = size(BW);
%setting grape radius - max and min
%=============================
Rmax = 25;
Rmin =8;

%== Acum is the counting array

acum (Row,Col,Rmax) = 0;



% transforming to parameter space
%=============================
for i=1:Row
   for j=1:Col
       if (BW(i,j) == 1)
            for k=Rmin:Rmax
                 for theta=1:360
                        Cy =round( i - k*sin(theta*pi/180));
                        Cx =round( j + k*cos(theta*pi/180));
                        if ((Cx>0)&&(Cy>0)&&(Cx<=Col)&&(Cy<=Row))
                            acum(Cy,Cx,k) = acum(Cy,Cx,k) + 1;
                        end 
                 end
            end
            
       end
   end
end
   


% selscting radiuses and leaving only circlular origin edges
%======================================================
D(Row,Col)=0;
for i=1:Row
    for j=1:Col
          rad = Rmin;
          count = 0;
         for k=Rmin:Rmax
              if (count< acum(i,j,k))
                  rad = k;
                  count = acum(i,j,k);
              end
         end
            % now the maximum radius was selected!!!
            k = rad;
          
                if (count>=100)
                  for theta=1:1:360
                          Xmark =round( j + k * [cos(theta*pi/180)]);
                          Ymark =round( i + k * [sin(theta*pi/180)]);
                          if ((Xmark>0)&&(Ymark>0)&&(Xmark<=Col)&&(Ymark<=Row))
                              if (BW(Ymark,Xmark) == 1)%&&(checkbetween(BW,i ,j ,rad, Rmin, tetha) <5))
                                    D(Ymark,Xmark)  =D(Ymark,Xmark) +1;
                              end
                          end
                  end
                end
         end
    end



%removes un circular parts fromparts from image
%============================================
window_size=26; %should be even (bigger than maximum radius
half= window_size/2;
 L= size(I,1) -half;
 M= size(I,2) -half;
 for i=half+1:L
    for j=half+1:M
        window=D(i-half:i+half,j-half:j+half);
        col = sum(window,1);
        row=sum(window,2);
        count=col(1)+ col(window_size+1) +row(1)+row(window_size+1);
        if (count==0)
            I(i-half:i+half,j-half:j+half)= zeros(size(window));
        end
    end
 end 




end